//Warm Tips:
//You can add the board manager by going to preferences and pasting this link: https://dl.espressif.com/dl/package_esp32_index.json
//When you download the program to development board, you need to press the IOO button for 1-2 seconds.
//IP Address for the board: http://192.168.43.171/
#include <WiFi.h>
#include <ESPAsyncWebServer.h>
#include <SPIFFS.h>
#include <Wire.h> //Includes the I2C library
#define SECOND_ADDR 9 //Defines secondary board Address as 9

const float Vratio = 5.128;   //ratio of voltage reduction based on experiment
const float VCC = 5.04;       // value of VCC of the board based on measurements
int Voltbits;                 // Variable to hold bits received from I2C
int Currbits;                 // Variable to hold current bits received from I2C
int Tempbits;                 // Variable to hold temperature bits received from I2C

//SSID Credentials to connect to ESP32
const char* ssid = "Galaxy A10e14B4";
const char* password = "zlas5050";

// Create AsyncWebServer object on port 80
AsyncWebServer server(80);



String Voltage(){//Function that converts voltbits value into voltage when it is called server
float Voltage = VCC*Voltbits*Vratio/255; 
  Serial.println(Voltage);
  return String(Voltage);
}

String Current(){//Function that converts currbits value into current when it is called by the server
  float Current = map(Currbits, 1,255, -5,5);
  Serial.println(Current);
  return String(Current);
}

String Temperature(){//Function that converts tempbits value into temperature when it is called by the server
  float TempC = map(Tempbits, 1, 255, 0,127);
  Serial.println(TempC);
  return String(TempC);
}
  

void setup() {
 
  //Start serial monitor
  Serial.begin(115200);
  
  //Initialize I2C communications as secondary
  Wire.begin();


 // Initialize SPIFFS
  if(!SPIFFS.begin()){
    Serial.println("An Error has occurred while mounting SPIFFS");
    return;
  }

  // Connect to Wi-Fi
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi..");
  }

  // Print ESP32 Local IP Address
  Serial.println(WiFi.localIP());

  // Route for root / web page
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send(SPIFFS, "/index.html");
  });

  // Call the Voltage function and send it to the server when requested
  server.on("/voltage", HTTP_GET, [](AsyncWebServerRequest *request){
  request->send_P(200, "text/plain", Voltage().c_str());
  });
  
  // Call the Current function and send it to the server when requested
  server.on("/current", HTTP_GET, [](AsyncWebServerRequest *request){
  request->send_P(200, "text/plain", Current().c_str());
  });
  
  // Call the Temperature function and send it to the server when requested
  server.on("/temperature", HTTP_GET, [](AsyncWebServerRequest *request){
  request->send_P(200, "text/plain", Temperature().c_str());
  });

  //Initialise the server
  server.begin();
  
}


void loop() {

Wire.requestFrom(SECOND_ADDR,3);
while (Wire.available()){
   Voltbits = Wire.read();  // Variable to hold bits received from I2C
   Currbits = Wire.read();  // Variable to hold current bits received from I2C
   Tempbits = Wire.read();  // Variable to hold temperature bits received from I2C 
}

}

//https://www.amazon.ca/KeeYees-Development-Bluetooth-Microcontroller-ESP-WROOM-32/dp/B07QCP2451/ref=sr_1_5?dchild=1&keywords=ESP32&qid=1623098100&sr=8-5
